--[[--------------------------------------------------------------------------------
  ItemSyncCore Tooltip Framework

  Author:  Derkyle
  Website: http://www.manaflux.com
-----------------------------------------------------------------------------------]]

--GameTooltip Hooks
local ISync_lOriginal_GameTooltip_SetOwner;
local ISync_lOriginal_GameTooltip_SetInventoryItem;
local ISync_lOriginal_GameTooltip_SetLootItem;
local ISync_lOriginal_GameTooltip_SetQuestItem;
local ISync_lOriginal_GameTooltip_SetQuestLogItem;
local ISync_lOriginal_GameTooltip_SetCraftItem;
local ISync_lOriginal_GameTooltip_SetTradeSkillItem;
local ISync_lOriginal_GameTooltip_SetMerchantItem;
local ISync_lOriginal_GameTooltip_SetAuctionSellItem;
local ISync_lOriginal_GameTooltip_OnEvent;
local ISync_lOriginal_GameTooltip_OnHide;

local ISync_lOriginal_AuctionFrameItem_OnEnter;
local ISync_lOriginal_ContainerFrameItemButton_OnEnter;
local ISync_lOriginal_ContainerFrame_Update;
local ISync_lOriginal_SetItemRef;

local ISync_lOriginal_AIOI_HOOK;
local ISync_lOriginal_MyInventoryItemEnter_HOOK;
local ISync_lOriginal_MyInventoryFrameUpate_HOOK;
local ISync_lOriginal_EngInventory_ModifyItemTooltip_HOOK;


function ISyncTooltip_OnLoad()

	------------------------------------------------------------------
	-- DO GAMETOOLTIP HOOKS
	------------------------------------------------------------------
	--GameTooltip.SetOwner
	ISync_lOriginal_GameTooltip_SetOwner = GameTooltip.SetOwner;
	GameTooltip.SetOwner = ISync_ToolTip_GT_SetOwner;
	
	--GameTooltip.SetInventoryItem
	ISync_lOriginal_GameTooltip_SetInventoryItem = GameTooltip.SetInventoryItem;
	GameTooltip.SetInventoryItem = ISync_ToolTip_GT_SetInventoryItem;
	
	--GameTooltip.SetLootItem
	ISync_lOriginal_GameTooltip_SetLootItem = GameTooltip.SetLootItem;
	GameTooltip.SetLootItem = ISync_ToolTip_GT_SetLootItem;
	
	--GameTooltip.SetQuestItem
	ISync_lOriginal_GameTooltip_SetQuestItem = GameTooltip.SetQuestItem;
	GameTooltip.SetQuestItem = ISync_ToolTip_GT_SetQuestItem;
	
	--GameTooltip.SetQuestLogItem
	ISync_lOriginal_GameTooltip_SetQuestLogItem = GameTooltip.SetQuestLogItem;
	GameTooltip.SetQuestLogItem = ISync_ToolTip_GT_SetQuestLogItem;
	
	--GameTooltip.SetCraftItem
	ISync_lOriginal_GameTooltip_SetCraftItem = GameTooltip.SetCraftItem;
	GameTooltip.SetCraftItem = ISync_ToolTip_GT_SetCraftItem;
	
	--GameTooltip.SetTradeSkillItem
	ISync_lOriginal_GameTooltip_SetTradeSkillItem = GameTooltip.SetTradeSkillItem;
	GameTooltip.SetTradeSkillItem = ISync_ToolTip_GT_SetTradeSkillItem;
	
	--GameTooltip.SetMerchantItem
	ISync_lOriginal_GameTooltip_SetMerchantItem = GameTooltip.SetMerchantItem;
	GameTooltip.SetMerchantItem = ISync_ToolTip_GT_SetMerchantItem;
	
	--GameTooltip.SetAuctionSellItem
	ISync_lOriginal_GameTooltip_SetAuctionSellItem = GameTooltip.SetAuctionSellItem;
	GameTooltip.SetAuctionSellItem = ISync_ToolTip_GT_SetAuctionSellItem;
	
	--Hook for GameTooltip_OnEvent Function
	ISync_lOriginal_GameTooltip_OnEvent = GameTooltip_OnEvent;
	GameTooltip_OnEvent = ISync_ToolTip_GT_OnEvent;
	
	--Hook the gametooltip onhide
	ISync_lOriginal_GameTooltip_OnHide = GameTooltip_OnHide;
	GameTooltip_OnHide = ISync_ToolTip_GT_OnHide;
	
	
	------------------------------------------------------------------
	------------------------------------------------------------------	
	
	--Auction items
	ISync_lOriginal_AuctionFrameItem_OnEnter = AuctionFrameItem_OnEnter;
	AuctionFrameItem_OnEnter = ISync_AuctionItemEnter;
	
	--Container Bags
	ISync_lOriginal_ContainerFrameItemButton_OnEnter = ContainerFrameItemButton_OnEnter;
	ContainerFrameItemButton_OnEnter = ISync_ContainerItemEnter;
	--Container Bags Update
	ISync_lOriginal_ContainerFrame_Update = ContainerFrame_Update;
	ContainerFrame_Update = ISync_ContainerItemEnter_Update;
	
	--for items that are clicked on in chat
	ISync_lOriginal_SetItemRef = SetItemRef;
	SetItemRef = ISync_SetItemRef;
  	

end


---------------------------------------------------
-- ISync_ToolTip_GetQuality
---------------------------------------------------
function ISyncTooltip_OnEvent()

	if( event == "VARIABLES_LOADED" ) then
	

		------------------------------------------------------------------
		------------------------------------------------------------------	

		--AllInOneInventory
		if(AllInOneInventory_ModifyItemTooltip) then
			ISync_lOriginal_AIOI_HOOK = AllInOneInventory_ModifyItemTooltip;
			AllInOneInventory_ModifyItemTooltip = ISync_AllInOneInventory_ModifyItemTooltip;
		end


		--MyInventory
		if (MyInventoryProfile) then
			ISync_lOriginal_MyInventoryItemEnter_HOOK = MyInventory_ContainerFrameItemButton_OnEnter;
			MyInventory_ContainerFrameItemButton_OnEnter = ISync_MyInventory_ContainerFrameItemButton_OnEnter;

			ISync_lOriginal_MyInventoryFrameUpate_HOOK = MyInventoryFrame_Update;
			MyInventoryFrame_Update = ISync_MyInventoryFrame_Update;


		elseif(ACUI_MyInventoryProfile) then

			ISync_lOriginal_MyInventoryItemEnter_HOOK = ACUI_MyInventoryFrameItemButton_OnEnter;
			ACUI_MyInventoryFrameItemButton_OnEnter = ISync_MyInventory_ContainerFrameItemButton_OnEnter;

			ISync_lOriginal_MyInventoryFrameUpate_HOOK = ACUI_MyInventoryFrame_Update;
			ACUI_MyInventoryFrame_Update = ISync_MyInventoryFrame_Update;

		end

		--EngInventory
		if(EngInventory_ModifyItemTooltip) then
			ISync_lOriginal_EngInventory_ModifyItemTooltip_HOOK = EngInventory_ModifyItemTooltip;
			EngInventory_ModifyItemTooltip = ISync_EngInventory_ModifyItemTooltip;
		end

	
	end

end


---------------------------------------------------
-- ISync_ToolTip_GetQuality
---------------------------------------------------
function ISync_ToolTip_GetQuality(sLink)
	
	if(not sLink) then return nil; end
	if(not ISync) then return nil; end
	
	local item, name, color, sParseLink;
	
	--start the loop to get the color
	for color, item, name in string.gfind(sLink, "|c(%x+)|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h|r") do
	
		local fluxColor = ISync:CheckColor(color, nil, 1);
		
		if(tonumber(fluxColor)) then
			return tonumber(fluxColor);
		end
		
	
	end--end for
	
	--return nil if nothing was found
	return nil;
	
end





--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------


---------------------------------------------------
-- ISync_ToolTip_GT_OnEvent
---------------------------------------------------
function ISync_ToolTip_GT_OnEvent()

    if event ~= "CLEAR_TOOLTIP" then
        return ISync_lOriginal_GameTooltip_OnEvent();
    elseif event == "CLEAR_TOOLTIP" then
    	
    	--old itemsmatrix way of doing things
    	--IM_CheckTooltip = ItemsMatrix_CheckOnTooltip();
    end 
    
end


---------------------------------------------------
-- ISync_ToolTip_GT_OnHide
---------------------------------------------------
function ISync_ToolTip_GT_OnHide()
	 ISync_lOriginal_GameTooltip_OnHide();
	
	--don't do anything with the parsing tooltip
	if(this:GetName() == "ISyncTooltip") then return nil; end
	
	
	--make sure this is only applied to the GameTooltip
	if(this:GetName() and this:GetName() == "GameTooltip") then
	
		GameTooltip.isDisplayDone = nil;
		GameTooltip_ClearMoney();
		ISync_GameTooltipTooltipIcon:Hide();
		ISync_MoneyTooltip:Hide();

	elseif(this:GetName() and this:GetName() == "ItemRefTooltip") then

		ISync_MoneyTooltipItemRef:Hide();
		
	elseif(this:GetName() ~= "GameTooltip" and this:GetName() ~= "ItemRefTooltip") then
	
		--gametooltip
		if(not GameTooltip:IsVisible()) then
			ISync_GameTooltipTooltipIcon:Hide();
			ISync_MoneyTooltip:Hide();
		end
		
		
		--ItemRefTooltip
		if(not ItemRefTooltip:IsVisible()) then
			ISync_MoneyTooltipItemRef:Hide();
			ISync_GameTooltipTooltipIcon:Hide();
		end
		
	end
	
	
end


---------------------------------------------------
-- ISync_ToolTip_GT_SetOwner
---------------------------------------------------
function ISync_ToolTip_GT_SetOwner(this, owner, anchor)

	--return to original to prevent errors
	ISync_lOriginal_GameTooltip_SetOwner(this, owner, anchor);
		
	--we want to store this for later use (like for Auctioneer)
	this.owner = owner;
	this.anchor = anchor;
		
end


---------------------------------------------------
-- ISync_ToolTip_GT_SetInventoryItem
---------------------------------------------------
function ISync_ToolTip_GT_SetInventoryItem(this, unit, slot)

	local sItem, sCooldown, sRepair = ISync_lOriginal_GameTooltip_SetInventoryItem(this, unit, slot);
	
	--get the link
	local link = GetInventoryItemLink(unit, slot);
	
	--if there is a link then process it
	if (link) then
	
		local quality = GetInventoryItemQuality(unit, slot);
		local Qty = GetInventoryItemCount(unit, slot);
		local name = ISync:NameFromLink(link);
		
		--if for some reason the above quality doesn't exist then
		--retrieve it ourselves
		if (not quality) then 
			quality = ISync_ToolTip_GetQuality(link); 
		end

		ISync_AddTooltip(GameTooltip, name, link, quality, Qty, nil);

	end

	return sItem, sCooldown, sRepair;
end


---------------------------------------------------
-- ISync_ToolTip_GT_SetLootItem
---------------------------------------------------
function ISync_ToolTip_GT_SetLootItem(this, slot)
	ISync_lOriginal_GameTooltip_SetLootItem(this, slot);
	
	local link = GetLootSlotLink(slot);
	local name = ISync:NameFromLink(link);
	
	--if there is a name then return information
	if (name and link) then
	
		local texture, item, Qty, quality = GetLootSlotInfo(slot);

		if (not quality) then 
			quality = ISync_ToolTip_GetQuality(link); 
		end
		
		ISync_AddTooltip(GameTooltip, name, link, quality, Qty, nil);

	end
end


---------------------------------------------------
-- ISync_ToolTip_GT_SetQuestItem
---------------------------------------------------
function ISync_ToolTip_GT_SetQuestItem(this, sOpt, slot)
	ISync_lOriginal_GameTooltip_SetQuestItem(this, sOpt, slot);
	
	local link = GetQuestItemLink(sOpt, slot);
	
	--if there is a link then return information
	if (link) then
	
		--get the quest item info
		local name, texture, Qty, quality, usable = GetQuestItemInfo(sOpt, slot);

		if(not name) then
			name = ISync:NameFromLink(link);
		end
		
		ISync_AddTooltip(GameTooltip, name, link, quality, Qty, nil);
	end
end


---------------------------------------------------
-- ISync_ToolTip_GT_SetQuestLogItem
---------------------------------------------------
function ISync_ToolTip_GT_SetQuestLogItem(this, sOpt, slot)
	ISync_lOriginal_GameTooltip_SetQuestLogItem(this, sOpt, slot);
	
	local link = GetQuestLogItemLink(sOpt, slot);
	
	--if link then process information
	if (link) then
		
		local name, texture, Qty, quality, usable = GetQuestLogRewardInfo(slot);
		
		--just in case the name wasn't grabbed (which never happens) we can get it ourselves
		if(not name) then
			name = ISync:NameFromLink(link);
		end
		
		--check quality
		if(not quality) then		
			quality = ISync_ToolTip_GetQuality(link);
		end

		ISync_AddTooltip(GameTooltip, name, link, quality, Qty, nil);

	end
end


---------------------------------------------------
-- ISync_ToolTip_GT_SetCraftItem
---------------------------------------------------
function ISync_ToolTip_GT_SetCraftItem(this, skill, slot)
	ISync_lOriginal_GameTooltip_SetCraftItem(this, skill, slot);
	
	--the slot determines if it's a regeant requirement
	if (slot) then
		
		--get link
		local link = GetCraftReagentItemLink(skill, slot);
		
		--check link
		if (link) then
		
			local name, texture, Qty, QtyHave = GetCraftReagentInfo(skill, slot);
			
				if(not name) then
					name = ISync:NameFromLink(link);
				end
		
			local quality = ISync_ToolTip_GetQuality(link);
			
			ISync_AddTooltip(GameTooltip, name, link, quality, Qty, nil);

		end
	else
		--get link
		local link = GetCraftItemLink(skill);
		
		--check link
		if (link) then
		
			local name = ISync:NameFromLink(link);
			local quality = ISync_ToolTip_GetQuality(link);
			
			ISync_AddTooltip(GameTooltip, name, link, quality, 1, nil);

		end
	end
end


---------------------------------------------------
-- ISync_ToolTip_GT_SetTradeSkillItem
---------------------------------------------------
function ISync_ToolTip_GT_SetTradeSkillItem(this, skill, slot)
	ISync_lOriginal_GameTooltip_SetTradeSkillItem(this, skill, slot);
	
	
	--the slot determines if it's a regeant requirement
	if (slot) then
	
		--get link
		local link = GetTradeSkillReagentItemLink(skill, slot);
		
		--check link
		if (link) then
		
			local name, texture, Qty, QtyHave = GetTradeSkillReagentInfo(skill, slot);
			local quality = ISync_ToolTip_GetQuality(link);
			
			ISync_AddTooltip(GameTooltip, name, link, quality, Qty, nil);

		end
	else
		--get link
		local link = GetTradeSkillItemLink(skill);
		
		--check link
		if (link) then
		
			local name = ISync:NameFromLink(link);
			local quality = ISync_ToolTip_GetQuality(link);
			
			ISync_AddTooltip(GameTooltip, name, link, quality, 1, nil);
			
		end
	end
end


---------------------------------------------------
-- ISync_ToolTip_GT_SetMerchantItem
---------------------------------------------------
function ISync_ToolTip_GT_SetMerchantItem(this, slot)
	ISync_lOriginal_GameTooltip_SetMerchantItem(this, slot);
	
	--get link
	local link = GetMerchantItemLink(slot);
	
	--check link
	if (link) then
	
		local name, texture, price, Qty, numAvailable, isUsable = GetMerchantItemInfo(slot);

			if(not name) then
				name = ISync:NameFromLink(link);
			end
				
		local quality = ISync_ToolTip_GetQuality(link);

		ISync_AddTooltip(GameTooltip, name, link, quality, Qty, price);

	end
end


---------------------------------------------------
-- ISync_ToolTip_GT_SetAuctionSellItem
---------------------------------------------------
function ISync_ToolTip_GT_SetAuctionSellItem(this)
	ISync_lOriginal_GameTooltip_SetAuctionSellItem(this);
	
    	local name, texture, Qty, quality, canUse, price = GetAuctionSellItemInfo();
    	
    	--make sure a name was returned
	if (name) then
	
		--search the owner bags to find the item they are auctioning
		for bag = 0, 4, 1 do
		
			size = GetContainerNumSlots(bag);
			
			--if size then continue
			if (size) then
			
				for slot = size, 1, -1 do
					
					--get link
					local link = GetContainerItemLink(bag, slot);
					
					--check link
					if (link) then
						
						--grab name from link
						local nameTS = ISync:NameFromLink(link);
						
						--if name matches that of which we are asking then display
						if(nameTS and nameTS == name) then

							
							ISync_AddTooltip(GameTooltip, name, link, quality, Qty, nil);
							
							return nil;
						end

					end
				
				end--end for
			end
		
		end--end for
	
	end--end name check
	
end


--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------


---------------------------------------------------
-- ISync_AuctionItemEnter
---------------------------------------------------
function ISync_AuctionItemEnter(type, index)
	
	--push to the original version
	ISync_lOriginal_AuctionFrameItem_OnEnter(type, index);

	--get AuctionItem link the type is usually "list" but can be passed differently
	local link = GetAuctionItemLink(type, index);
	
	--if there is a link (meaning an item is viewable) then get the name from the link
	if (link) then
	
		--grab variables
		local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner = GetAuctionItemInfo(type, index);

			if(not name) then
				name = ISync:NameFromLink(link);
			end

		ISync_AddTooltip(GameTooltip, name, link, quality, count, nil, 1);


		
	end--end link check
	
	
end



---------------------------------------------------
-- ISync_ContainerItemEnter
---------------------------------------------------
function ISync_ContainerItemEnter()
	 ISync_lOriginal_ContainerFrameItemButton_OnEnter();

	local frameID = this:GetParent():GetID();
	local buttonID = this:GetID();
	local link = GetContainerItemLink(frameID, buttonID);
	
	if (link) then
		local texture, itemCount, locked, quality, isReadable = GetContainerItemInfo(frameID, buttonID);
		
		--check quality
		if(not quality) then		
			quality = ISync_ToolTip_GetQuality(link);
		end
		
		local nameTS = ISync:NameFromLink(link);
		
		ISync_AddTooltip(GameTooltip, nameTS, link, quality, itemCount, nil, 1);
	end
end


---------------------------------------------------
-- ISync_ContainerItemEnter_Update
---------------------------------------------------
--IF THIS FUNCTION IS WRONG IN ANYWAY
--IT WILL POP UP A MESSAGE STATING ("Attempt to index a nil") it won't tell you
--what line or anything.  I pulled my hair with this one.
function ISync_ContainerItemEnter_Update(frame)
	 ISync_lOriginal_ContainerFrame_Update(frame);

	local frameID = frame:GetID();
	local frameName = frame:GetName();
	local iButton;
	
	for iButton = 1, frame.size do
	
		local button = getglobal(frameName.."Item"..iButton);
		
		if (GameTooltip:IsOwned(button)) then
		
			local buttonID = button:GetID();
			local link = GetContainerItemLink(frameID, buttonID);
			
			if (link) then
	
				local texture, itemCount, locked, quality, readable = GetContainerItemInfo(frameID, buttonID);

				--check quality
				if(not quality) then		
					quality = ISync_ToolTip_GetQuality(link);
				end
				
				local nameTS = ISync:NameFromLink(link);
				
				ISync_AddTooltip(GameTooltip, nameTS, link, quality, itemCount, nil, 1);
		
			end
		end
	end

end


---------------------------------------------------
-- ISync_SetItemRef
-- Chat Clickable Hyperlinks
-----------------------------------------------
function ISync_SetItemRef( link, name, button)
	 ISync_lOriginal_SetItemRef( link, name, button);

	--make sure we have a link to work with
	if(not link or not name) then return nil; end
	
	--make sure we have a tooltip to work with duh
	if(not ItemRefTooltip) then return nil; end
	
	--we need to weed out item links and player tooltips.
	if( strsub(link, 1, 6) ~= "Player" ) then
	
		if( ItemRefTooltip:IsVisible() and link) then
		
			if (link) then
			
				local nameTS = ItemRefTooltipTextLeft1:GetText();
				
				---------------------------------
				--Grab the texture if it's possible
				local iStart,iEnd, sSID = string.find(link,"(item:%d+:%d+:%d+:%d+)");
				
				local sTexture = nil; --reset
				
				if(sSID) then
				
					local name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, axStack_X, invType_X, icon_X  = GetItemInfo(sSID);
					
					--set the icon
					sTexture = icon_X;
				
				end
				---------------------------------
				
				if(not DressUpFrame:IsVisible()) then
					ISync_AddTooltip(ItemRefTooltip, nameTS, link, nil, 1, nil, 1, nil, sTexture);
				end
				
				--reset it after it's been added so that we can always see it
				ItemRefTooltip.isDisplayDone = nil;
			end

		end
		
	end
	
		
	
end

--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------


---------------------------------------------------
-- ISync_AddTooltip
---------------------------------------------------
function ISync_AddTooltip(sTooltip, sName, sLink, sQuality, sQty, sPrice, sOpt, sOpt2, sTextureChk)
	
	--do not continue unless we have options to work with
	if(not ISyncOpt) then return nil; end
	
	--by default hide the tooltip money frame
	if(sTooltip ~= ItemRefTooltip) then
		ISync_MoneyTooltip:Hide();
	end
	
	--don't continue if we have already shown this
	if(sTooltip.isDisplayDone) then return nil; end

	--sOpt2 is used to force the tooltip to show information even if it's at a merchant
	if(not sOpt2) then
		if(MerchantFrame:IsVisible()) then return nil; end
	end
	
	--check for money display check
	if(not ISyncOpt.ShowMoneyIcons) then return nil; end
	

	--only allow if either price or vendor is showing
	if(sLink and ISyncOpt and ISyncOpt.MONEYSET and ISyncOpt.PRICE or ISyncOpt.VENDOR and ISyncOpt.ShowMoneyIcons) then

		--check for the strings required for showing information
		if(not ISyncOpt.GOLD or not ISyncOpt.SILVER or not ISyncOpt.COPPER) then return nil; end
	
		--this optinal parameters determines if we are sending a link
		--or the actual item id itself.  In which case we don't need to 'grab' it.
		
		local sChk = 0;
		local priceChk = 0;
		local vendorChk = 0;
		local sFrameGet;
		
		
		if(not sName) then
			sName = ISync:NameFromLink(sLink);
			--if still no name then exit
			if(not sName) then return nil; end
		end
			
		
		--do we show the texture or what?
		if(sTextureChk and sTooltip == GameTooltip) then
		
			--make sure that the TooltipItemIcon mod is not installed.  If it is
			--then duplicate icons show up.  That mod does the same thing as ItemSync item icons.
			if(not TooltipItemIcon_OnLoad and ISyncOpt and ISyncOpt.CLEAN_ShowItemIcon and ISyncOpt.CLEAN_ShowItemIcon == 1) then
			
				ISync_GameTooltipTooltipIconIconTexture:SetTexture(sTextureChk);
				ISync_GameTooltipTooltipIcon:Show();
			
			end
			
			
		--do we show the texture or what?
		elseif(sTextureChk and sTooltip == ItemRefTooltip) then
		
			--make sure that the TooltipItemIcon mod is not installed.  If it is
			--then duplicate icons show up.  That mod does the same thing as ItemSync item icons.
			if(not TooltipItemIcon_OnLoad and ISyncOpt and ISyncOpt.CLEAN_ShowItemIcon and ISyncOpt.CLEAN_ShowItemIcon == 1) then
		
				--to make sure it doesn't conflict with equipcompare
				if(EquipCompare_Enabled) then
				ISync_ItemRefTooltipIcon:SetPoint("TOPLEFT", "ItemRefTooltip", "TOPLEFT" , 3, 39);
				end

				ISync_ItemRefTooltipIconIconTexture:SetTexture(sTextureChk);
				ISync_ItemRefTooltipIcon:Show();
			
			end
			
		elseif(sTooltip == GameTooltip) then
		
			ISync_GameTooltipTooltipIcon:Hide();
			
		elseif(sTooltip == ItemRefTooltip) then
		
			ISync_ItemRefTooltipIcon:Hide();
			
		end
		
		
		--fix the Qty
		if(not sQty) then sQty = 1; end
		if(sQty < 1) then sQty = 1; end
		
		
		--make sure we have data to work with
		if(ISyncDB and ISyncDB[ISync_RealmNum] and not ISyncDB[ISync_RealmNum][sName]) then return nil; end

		-----------------------------
		
		--if price then show it
		if(ISyncOpt.PRICE == 1 and ISyncOpt.ShowMoneyIcons == 0) then
		
			local sMoneySum = ISync:GetData(sName, "price");
			
			--only show if we have something to work with
			if(sMoneySum and tonumber(sMoneySum) > 0) then
				
				sQty = tonumber(sQty); --just in case
				sMoneySum = tonumber(sMoneySum); --just in case
				sMoneySum = sMoneySum * sQty;
				
				--get the split amount
				local gold, silver, copper = ISync_ReturnSplitMoney(sMoneySum);
				
				--add zero's to work with
				if(not gold) then gold = 0; end
				if(not silver) then silver = 0; end
				if(not copper) then copper = 0; end
				
				local sStoreString = "";
				
				-----------------------------------
				--gold
				if(gold ~= 0) then
				
					sStoreString = string.format(ISyncOpt.GOLD, gold);
				end
				
				--silver
				if(gold ~= 0 or silver ~= 0) then
					
					--add double zero's
					if(silver == 0) then
						sStoreString = sStoreString..string.format(ISyncOpt.SILVER, "00");
					else
						sStoreString = sStoreString..string.format(ISyncOpt.SILVER, silver);
					end

				end
				
				--copper
				if(gold ~= 0 or silver ~= 0 or  copper ~= 0) then

					--add double zero's
					if(copper == 0) then
						sStoreString = sStoreString..string.format(ISyncOpt.COPPER, "00");
					else
						sStoreString = sStoreString..string.format(ISyncOpt.COPPER, copper);
					end
					
				end
				-----------------------------------
				
					if(sStoreString ~= "") then
					
						--check to see if the empty gap has already been added
						if(sChk == 0) then
							sTooltip:AddLine(" ");
							sChk = 1;
						end
					
					
						sTooltip:AddDoubleLine("|c00FFFF00"..ISYNC_COST.."[|r|c00BDFCC9"..sQty.."|r|c00FFFF00]:|r", sStoreString,1,1,1,1,1,1);


						sTooltip.isDisplayDone = 1;
					
					end
					
			else
				--show nosellvalue
				if(sMoneySum and tonumber(sMoneySum) == -1) then
				
						--check to see if the empty gap has already been added
						if(sChk == 0) then
							sTooltip:AddLine(" ");
							sChk = 1;
						end
						
					sTooltip:AddLine("|c00FFFF00"..ISYNC_NOSELLPRICE.."|r");
					
					sTooltip.isDisplayDone = 1;
				end
				
				
			end--if(sMoneySum) then
			
		end--end price option check
		-----------------------------------


		--if price then show it
		if(ISyncOpt.VENDOR == 1 and ISyncOpt.ShowMoneyIcons == 0) then
		
			local sMoneySum = ISync:GetData(sName, "vendor");
			local sVendQty = ISync:GetData(sName, "vendorqty");
			
			if(not sVendQty) then sVendQty = 1; end
			
			--only show if we have something to work with
			if(sMoneySum and tonumber(sMoneySum) > 0 and tonumber(sVendQty) > 0) then
				
				sMoneySum = tonumber(sMoneySum); --just in case
				
				--get the split amount
				local gold, silver, copper = ISync_ReturnSplitMoney(sMoneySum);
				
				--add zero's to work with
				if(not gold) then gold = 0; end
				if(not silver) then silver = 0; end
				if(not copper) then copper = 0; end
				
				local sStoreString = "";
				
				-----------------------------------
				--gold
				if(gold ~= 0) then
				
					sStoreString = string.format(ISyncOpt.GOLD, gold);
				end
				
				--silver
				if(gold ~= 0 or silver ~= 0) then
					
					--add double zero's
					if(silver == 0) then
						sStoreString = sStoreString..string.format(ISyncOpt.SILVER, "00");
					else
						sStoreString = sStoreString..string.format(ISyncOpt.SILVER, silver);
					end

				end
				
				--copper
				if(gold ~= 0 or silver ~= 0 or  copper ~= 0) then

					--add double zero's
					if(copper == 0) then
						sStoreString = sStoreString..string.format(ISyncOpt.COPPER, "00");
					else
						sStoreString = sStoreString..string.format(ISyncOpt.COPPER, copper);
					end
					
				end
				-----------------------------------
				
					if(sStoreString ~= "") then
					
						--check to see if the empty gap has already been added
						if(sChk == 0) then
							sTooltip:AddLine(" ");
							sChk = 1;
						end
						
						sTooltip:AddDoubleLine("|c00FFFF00"..ISYNC_VENDORCOST.."[|r|c00BDFCC9"..sVendQty.."|r|c00FFFF00]:|r", sStoreString,1,1,1,1,1,1);


						sTooltip.isDisplayDone = 1;
					
					end
					
				
			end--if(sMoneySum) then
			
		end--end price option check
		-----------------------------------
		
		
--//NOW DO THE NEW MONEY ICON CHECK
--////////////////////////////////////////////////////////////////////////////////////////////////////////////

		sChk = 0; --reset

		-----------------------------
		
		--if price then show it
		if(ISyncOpt.PRICE == 1 and ISyncOpt.ShowMoneyIcons == 1) then
		
			local sMoneySum = ISync:GetData(sName, "price");
			
			
			--only show if we have something to work with
			if(sMoneySum and tonumber(sMoneySum) > 0) then
			
				
				sQty = tonumber(sQty); --just in case
				sMoneySum = tonumber(sMoneySum); --just in case
				sMoneySum = sMoneySum * sQty;
				
				
				--check to see if the empty gap has already been added
				if(sChk == 0) then
					sTooltip:AddLine(" ");
					sChk = 1;
				end
					
					--add the line so we know where to put text
					sTooltip:AddLine(" ", 0, 0, 0);
					
					
					if(sTooltip == ItemRefTooltip) then
						sFrameGet = "ISync_MoneyTooltipItemRef";
					else
						sFrameGet = "ISync_MoneyTooltip";
					end
					
					
					local numLines = sTooltip:NumLines();
					local text = getglobal(sFrameGet.."Text1");
					local money = getglobal(sFrameGet.."Money1");
					local newLine = sTooltip:GetName().."TextLeft"..numLines;


					MoneyFrame_Update(sFrameGet.."Money1", sMoneySum);
					text:SetText("|c00FFFF00"..ISYNC_COST.."[|r|c00BDFCC9"..sQty.."|r|c00FFFF00]:  |r");
					text:Show();
					money:Show();

					--set the point at it's new location
					text:ClearAllPoints();
					text:SetPoint("LEFT", newLine, "LEFT", 0, 0);
					
					--resize the font just in case
					text:SetWidth(text:GetStringWidth());
					
					--fix the tooltip width if small
					local getTextWidth = text:GetWidth();
					local getMoneyWidth = money:GetWidth();
					local getTooltipWidth= getglobal(sTooltip:GetName().."TextLeft1"):GetWidth();

					--check
					if( (getTextWidth + getMoneyWidth) > getTooltipWidth ) then

						getglobal(sTooltip:GetName().."TextLeft1"):SetWidth((getTextWidth + getMoneyWidth) + 10);	

					end
									
		
					--set as done
					sTooltip.isDisplayDone = 1;
					
					priceChk = 1;
					
			--show nosellvalue
			elseif(sMoneySum and tonumber(sMoneySum) == -1) then
							
					if(sTooltip == ItemRefTooltip) then
						sFrameGet = "ISync_MoneyTooltipItemRef";
					else
						sFrameGet = "ISync_MoneyTooltip";
					end
					
					local text = getglobal(sFrameGet.."Text1");
					local money = getglobal(sFrameGet.."Money1");
					money:Hide();
					text:Hide();

						--check to see if the empty gap has already been added
						if(sChk == 0) then
							sTooltip:AddLine(" ");
							sChk = 1;
						end
					
					sTooltip:AddLine("|c00FFFF00"..ISYNC_NOSELLPRICE.."|r");
								
					--set as done
					sTooltip.isDisplayDone = 1;
					
					priceChk = 1;

				
				
			else
					if(sTooltip == ItemRefTooltip) then
						sFrameGet = "ISync_MoneyTooltipItemRef";
					else
						sFrameGet = "ISync_MoneyTooltip";
					end
					
					local text = getglobal(sFrameGet.."Text1");
					local money = getglobal(sFrameGet.."Money1");
					money:Hide();
					text:Hide();
					
					priceChk = 0;
				
			end--if(sMoneySum) then
			
		end--end price option check
		-----------------------------------


		--if price then show it
		if(ISyncOpt.VENDOR == 1 and ISyncOpt.ShowMoneyIcons == 1) then
		
			local sMoneySum = ISync:GetData(sName, "vendor");
			local sVendQty = ISync:GetData(sName, "vendorqty");
			
			if(not sVendQty) then sVendQty = 1; end
			
			--only show if we have something to work with
			if(sMoneySum and tonumber(sMoneySum) > 0 and tonumber(sVendQty) > 0) then
				
				sMoneySum = tonumber(sMoneySum); --just in case
				
				--check to see if the empty gap has already been added
				if(sChk == 0) then
					sTooltip:AddLine(" ");
					sChk = 1;
				end
					
					--add the line so we know where to put text
					sTooltip:AddLine(" ", 0, 0, 0);
					
					if(sTooltip == ItemRefTooltip) then
						sFrameGet = "ISync_MoneyTooltipItemRef";
					else
						sFrameGet = "ISync_MoneyTooltip";
					end

					local numLines = sTooltip:NumLines();
					local text = getglobal(sFrameGet.."Text2");
					local money = getglobal(sFrameGet.."Money2");
					local newLine = sTooltip:GetName().."TextLeft"..numLines;


					MoneyFrame_Update(sFrameGet.."Money2", sMoneySum);
					text:SetText("|c00FFFF00"..ISYNC_VENDORCOST.."[|r|c00BDFCC9"..sVendQty.."|r|c00FFFF00]:  |r");
					text:Show();
					money:Show();

					--set the point at it's new location
					text:ClearAllPoints();
					text:SetPoint("LEFT", newLine, "LEFT", 0, 0);
					
					--resize the font just in case
					text:SetWidth(text:GetStringWidth());
					
					--fix the tooltip width if small
					local getTextWidth = text:GetWidth();
					local getMoneyWidth = money:GetWidth();
					local getTooltipWidth= getglobal(sTooltip:GetName().."TextLeft1"):GetWidth();

					--check
					if( (getTextWidth + getMoneyWidth) > getTooltipWidth ) then

						getglobal(sTooltip:GetName().."TextLeft1"):SetWidth((getTextWidth + getMoneyWidth) + 10);	

					end
		
					--set as done
					sTooltip.isDisplayDone = 1;
					
					vendorChk = 1;
				
			else
			
					if(sTooltip == ItemRefTooltip) then
						sFrameGet = "ISync_MoneyTooltipItemRef";
					else
						sFrameGet = "ISync_MoneyTooltip";
					end
					
					local text = getglobal(sFrameGet.."Text2");
					local money = getglobal(sFrameGet.."Money2");
					money:Hide();
					text:Hide();
					
					vendorChk = 0;
				
			end--if(sMoneySum) then
			
		end--end price option check
		-----------------------------------
		
		
		--////////////////START SHOW MONEY CHECK
		--configure the money icons ONLY if the user is using it
		--if we are using money icons then show the tooltip frame once everything is set
		if(ISyncOpt.ShowMoneyIcons == 1) then
		
			--check that the sell text isn't smaller then the vendor one
			if(priceChk == 1 and vendorChk == 1) then
			
				--get the frame
				if(sTooltip == ItemRefTooltip) then
					sFrameGet = "ISync_MoneyTooltipItemRef";
				else
					sFrameGet = "ISync_MoneyTooltip";
				end
					
			
				local getPriceWidth = getglobal(sFrameGet.."Text1"):GetWidth();
				local getVendorWidth = getglobal(sFrameGet.."Text2"):GetWidth();
				local diffWidth = 0;
				
				--if vendor is bigger then price
				if(getPriceWidth < getVendorWidth) then
				
					 getglobal(sFrameGet.."Text1"):SetWidth(getVendorWidth);
					 
					 getglobal(sFrameGet.."Text1"):SetJustifyH("LEFT");
				
					 priceChk = 0;
					 vendorChk = 0;
					
				--if price is bigger then vendor
				elseif(getVendorWidth < getPriceWidth) then	 
				
				
					 getglobal(sFrameGet.."Text2"):SetWidth(getPriceWidth);
					 
					 getglobal(sFrameGet.."Text2"):SetJustifyH("LEFT");
				
					 priceChk = 0;
					 vendorChk = 0;
					 
				end
				
					
				
			else
					priceChk = 0;
					vendorChk = 0;
					
			end--if(priceChk == 1 and vendorChk == 1) then
			
			
			--show or hide according to which tooltip is requesting money
			if(sTooltip == ItemRefTooltip) then
				ISync_MoneyTooltipItemRef:Show();
			else
				ISync_MoneyTooltip:Show();
			end

			
		else

			--don't show anything cause were not using money coins			
			ISync_MoneyTooltipItemRef:Hide();
			ISync_MoneyTooltip:Hide();

					
		end
		--////////////////END SHOW MONEY CHECK
		
		
		
		--show the edited tooltip
		sTooltip:Show();

	end--end variable checks


end


---------------------------------------------------
-- ISync_ReturnSplitMoney
---------------------------------------------------
function ISync_ReturnSplitMoney(sMoney)

		--convert the long money value into seperate variables
		local gold = floor(sMoney / (COPPER_PER_SILVER * SILVER_PER_GOLD));
		local silver = floor((sMoney - (gold * COPPER_PER_SILVER * SILVER_PER_GOLD)) / COPPER_PER_SILVER);
		local copper = mod(sMoney, COPPER_PER_SILVER);


	return gold, silver, copper;

end




--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------


---------------------------------------------------
-- ISync_CheckModTooltip
---------------------------------------------------
function ISync_CheckModTooltip(sTooltip, sName, sLink, sQty, sQuality)

	--check for tooltip info
	if(not sTooltip or not sName or not sQty) then return nil; end

	--make sure we aren't repeating
	if(sTooltip.isDisplayDone) then return nil; end
	

	--auctionmatrix
	if(ISyncOpt and ISyncOpt.MOD_AuctionMatrix and ISyncOpt.MOD_AuctionMatrix == 1 and AuctionMatrix_AddTooltipMoney) then
		AuctionMatrix_AddTooltipMoney(sName, sTooltip, sQty);
	end

	
	--do auctioneer if not present
	if(ISyncOpt and ISyncOpt.MOD_Auctioneer and ISyncOpt.MOD_Auctioneer == 1 and ENHTOOLTIP_VERSION and not EnhTooltip) then
	
		--grab the hex color
		local fluxcolor = ISync:CheckColor(nil, tonumber(sQuality), 2)
			
			--it doesn't exist so exit
			if(not fluxcolor) then return nil; end
		
		--it does exist so use it
		local Dlink = "|c"..fluxcolor.. "|H"..sLink.."|h["..sName.."]|h|r";
		
		--now send it
		if (Dlink and TT_Clear and TT_TooltipCall and TT_Show) then
			TT_Clear();
			TT_TooltipCall(sTooltip, sName, Dlink, sQuality, sQty, 0);
			TT_Show(sTooltip);
		end
		
		
	elseif(ISyncOpt and ISyncOpt.MOD_Auctioneer and ISyncOpt.MOD_Auctioneer == 1 and ENHTOOLTIP_VERSION and EnhTooltip and EnhTooltip.TooltipCall) then
	

		--check it's not already showing
		if(EnhancedTooltip:IsVisible()) then
		
			return nil;
		end
		
	
		--grab the hex color
		local fluxcolor = ISync:CheckColor(nil, tonumber(sQuality), 2)
			
			--it doesn't exist so exit
			if(not fluxcolor) then return nil; end
		
		--it does exist so use it
		local Dlink = "|c"..fluxcolor.. "|H"..sLink.."|h["..sName.."]|h|r";
		

		if(Dlink) then
		
			EnhTooltip.ClearTooltip();
			
			EnhTooltip.TooltipCall(sTooltip, sName, Dlink, sQuality, sQty, 0);
			
			EnhTooltip.ShowTooltip(sTooltip);
			

		end
	
	
	end
	
	
	--regeantinfo
	if(ISyncOpt and ISyncOpt.MOD_ReagentInfo and ISyncOpt.MOD_ReagentInfo == 1 and ReagentInfo_AddTooltipInfo) then

		ReagentInfo_AddTooltipInfo(sTooltip, sName);

	end
	
		

end




---------------------------------------------------
-- ISync_AllInOneInventory_ModifyItemTooltip
---------------------------------------------------
function ISync_AllInOneInventory_ModifyItemTooltip(bag, slot, tooltipName)
	 ISync_lOriginal_AIOI_HOOK(bag, slot, tooltipName);

	
	--only activate if the user has enabled it
	if(not ISyncOpt) then return nil; end
	if(not ISyncOpt.MOD_AIOI) then return nil; end
     	if(ISyncOpt.MOD_AIOI == 0) then return nil; end
     
     	--grab the tooltip
	local tooltip = getglobal(tooltipName);
	
	if ( not tooltip ) then
	  tooltip = getglobal("GameTooltip");
	  tooltipName = "GameTooltip";
	end
	if ( not tooltip ) then
	  return false;
	end

	--make sure we don't add stuff while at merchant or in repairmode
	local shouldModify = true;
	if ( InRepairMode() and MerchantFrame:IsVisible() ) then
		shouldModify = false;
	end
	

	if ( shouldModify ) then

		local itemInfo = AllInOneInventoryItems_GetInfo(bag, slot);
		local link = GetContainerItemLink(bag, slot);
		local quality = ISync_ToolTip_GetQuality(link); 
		
		---------------------------------
		--itemInfo.n = name of item
		if(itemInfo.n) then --it exists so continue

			ISync_AddTooltip(tooltip, itemInfo.n, link, quality, itemInfo.c, nil, nil, nil, nil);
			
		end	
		---------------------------------
		
		

	end	
	
	

end



---------------------------------------------------
-- ISync_MyInventory_ContainerFrameItemButton_OnEnter
---------------------------------------------------
function ISync_MyInventory_ContainerFrameItemButton_OnEnter()
     	 ISync_lOriginal_MyInventoryItemEnter_HOOK();
	
	
	--only activate if the user has enabled it
	if(not ISyncOpt) then return nil; end
	if(not ISyncOpt.MOD_MyInventory) then return nil; end
     	if(ISyncOpt.MOD_MyInventory == 0) then return nil; end
     	
     	
	if (GameTooltip:IsVisible() and not InRepairMode()) then
	
		  if(ACUI_MyInventoryProfile) then
		  	local bag, slot = ACUI_MyInventory_GetIdAsBagSlot(this:GetID());
		  else
		  	local bag, slot = MyInventory_GetIdAsBagSlot(this:GetID());
		  end
		  
			--make sure we have something to work with
			if(not bag or not slot) then return nil; end
			
		  local link = GetContainerItemLink(bag, slot);
		  local name = ISync:NameFromLink(link);


		  if(link and name and bag and slot) then

			local texture, itemCount, locked, quality, isReadable = GetContainerItemInfo(bag, slot);

			--check quality
			if(not quality) then		
				quality = ISync_ToolTip_GetQuality(link);
			end

			ISync_AddTooltip(GameTooltip, name, link, quality, itemCount, nil);
			

		  end--  if(link and name) then
	  
	  
	end--if (GameTooltip:IsVisible() and not InRepairMode()) then
     
end



---------------------------------------------------
-- ISync_MyInventoryFrame_Update
---------------------------------------------------
function ISync_MyInventoryFrame_Update(frame)
         ISync_lOriginal_MyInventoryFrameUpate_HOOK(frame);
	
	
	--only activate if the user has enabled it
	if(not ISyncOpt) then return nil; end
	if(not ISyncOpt.MOD_MyInventory) then return nil; end
     	if(ISyncOpt.MOD_MyInventory == 0) then return nil; end
     	
	local name = frame:GetName();
	
	for j=1, frame.size, 1 do
	  local itemButton = getglobal(name.."Item"..j);

	  if (GameTooltip:IsVisible() and GameTooltip:IsOwned(itemButton)) then
	       tooltip = getglobal("GameTooltip");
	       tooltipName = "GameTooltip";

	       if ( not tooltip ) then
		    return false;
	       end

		if(ACUI_MyInventoryProfile) then
	       	 	local bag, slot = ACUI_MyInventory_GetIdAsBagSlot(itemButton:GetID());
		else
	       		local bag, slot = MyInventory_GetIdAsBagSlot(itemButton:GetID());
	       	end
	       
			--make sure we have something to work with
			if(not bag or not slot) then return nil; end
			
		  local link = GetContainerItemLink(bag, slot);
		  local nameItem = ISync:NameFromLink(link);


		  if(link and nameItem and bag and slot) then

			local texture, itemCount, locked, quality, isReadable = GetContainerItemInfo(bag, slot);

			--check quality
			if(not quality) then		
				quality = ISync_ToolTip_GetQuality(link);
			end


			ISync_AddTooltip(GameTooltip, nameItem, link, quality, itemCount, nil);
			

		  end--  if(link and name) then
	       
	       
	  end--if (GameTooltip:IsVisible() and GameTooltip:IsOwned(itemButton)) then
	end--for j=1, frame.size, 1 do
     
     
end




---------------------------------------------------
-- ISync_EngInventory_ModifyItemTooltip
---------------------------------------------------
function ISync_EngInventory_ModifyItemTooltip(bag, slot, tooltipName, itm, dont_call_auctioneer)
	 ISync_lOriginal_EngInventory_ModifyItemTooltip_HOOK(bag, slot, tooltipName, itm, dont_call_auctioneer);

	local nameItem = itm["itemname"];
	local link = GetContainerItemLink(bag, slot);
	local texture, itemCount, locked, quality, isReadable = GetContainerItemInfo(bag, slot);

	--check quality
	if(not quality) then		
		quality = ISync_ToolTip_GetQuality(link);
	end
	
	--set to an object
	tooltipName = getglobal(tooltipName);
	
	ISync_AddTooltip(tooltipName, nameItem, link, quality, itemCount, nil);

end
